package com.hotwj.platform.config.courseResource.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.config.courseResource.domain.HotCourseResource;
import com.hotwj.platform.config.courseResource.domain.bo.HotCourseResourceBo;
import com.hotwj.platform.config.courseResource.domain.vo.HotCourseResourceVo;
import com.hotwj.platform.config.courseResource.mapper.HotCourseResourceMapper;
import com.hotwj.platform.config.courseResource.service.IHotCourseResourceService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 课程-资源关联Service业务层处理
 *
 * @author shihongwei
 * @date 2025-12-23
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotCourseResourceServiceImpl implements IHotCourseResourceService {

    private final HotCourseResourceMapper baseMapper;

    /**
     * 查询课程-资源关联
     *
     * @param id 主键
     * @return 课程-资源关联
     */
    @Override
    public HotCourseResourceVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询课程-资源关联列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 课程-资源关联分页列表
     */
    @Override
    public TableDataInfo<HotCourseResourceVo> queryPageList(HotCourseResourceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotCourseResource> lqw = buildQueryWrapper(bo);
        Page<HotCourseResourceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的课程-资源关联列表
     *
     * @param bo 查询条件
     * @return 课程-资源关联列表
     */
    @Override
    public List<HotCourseResourceVo> queryList(HotCourseResourceBo bo) {
        LambdaQueryWrapper<HotCourseResource> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotCourseResource> buildQueryWrapper(HotCourseResourceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotCourseResource> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotCourseResource::getId);
        lqw.eq(bo.getCompanyId() != null, HotCourseResource::getCompanyId, bo.getCompanyId());
        lqw.eq(bo.getCourseId() != null, HotCourseResource::getCourseId, bo.getCourseId());
        lqw.eq(bo.getResourceType() != null, HotCourseResource::getResourceType, bo.getResourceType());
        lqw.eq(bo.getResourceId() != null, HotCourseResource::getResourceId, bo.getResourceId());
        lqw.eq(bo.getSortOrder() != null, HotCourseResource::getSortOrder, bo.getSortOrder());
        return lqw;
    }

    /**
     * 新增课程-资源关联
     *
     * @param bo 课程-资源关联
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotCourseResourceBo bo) {
        HotCourseResource add = MapstructUtils.convert(bo, HotCourseResource.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改课程-资源关联
     *
     * @param bo 课程-资源关联
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotCourseResourceBo bo) {
        HotCourseResource update = MapstructUtils.convert(bo, HotCourseResource.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotCourseResource entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除课程-资源关联信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
